// $Id: slideshow_framework.js,v 1.1.2.2 2010/06/22 06:02:48 hakulicious Exp $

var slideshowFramework = {};
slideshowFramework.current = 0;
slideshowFramework.total= 0;
slideshowFramework.status = 1;
slideshowFramework.timeout = false;
slideshowFramework.titlesExist = false;
slideshowFramework.descriptionsExist = false;
slideshowFramework.fullscreenOn = false;

slideshowFramework.buttons = function()
{
	slideshowFramework.setButtonFaders();
	slideshowFramework.setButtonListeners();
};

slideshowFramework.setButtonFaders = function()
{
	$("#selected_image").hover
	(
		function()
		{
			$("#slideshow_left_button, #slideshow_right_button").fadeIn();
		},
		function()
		{
			$("#slideshow_left_button, #slideshow_right_button").fadeOut();
		}
	);
};

slideshowFramework.setButtonListeners = function()
{
	var local = slideshowFramework;
	$("#slideshow_left_button a").click(function()
	{
		if(local.status)
		{
			slideshowFramework.current = ((slideshowFramework.current - 1) >= 0) ? slideshowFramework.current - 1 : (slideshowFramework.total - 1);
			local.exchangeImage();
		}
		return false;
	});
	$("#slideshow_right_button a").click(function()
	{
		if(local.status)
		{
			slideshowFramework.current = ((slideshowFramework.current + 1) < slideshowFramework.total) ? slideshowFramework.current + 1 : 0;
			local.exchangeImage();
		}
		return false;
	});
};

slideshowFramework.exchangeImage = function()
{
	var local = slideshowFramework;
	var settings = Drupal.settings.slideshowFramework;
	if(local.status)
	{
		slideshowFramework.status = 0;
		clearTimeout(slideshowFramework.timeout);
		if(local.titlesExist)
		{
			$("#slideshow_framework_image_titles .slideshow_framework_image_title").slideUp(settings.fadeSpeed);
			$(".slideshow_framework_image_title:eq(" + slideshowFramework.current + ")").slideDown(settings.fadeSpeed);
		}
		if(local.descriptionsExist)
		{
			$("#slideshow_framework_image_descriptions .slideshow_framework_image_description").slideUp(settings.fadeSpeed);
			$(".slideshow_framework_image_description:eq(" + slideshowFramework.current + ")").slideDown(settings.fadeSpeed);
		}
		$("#selected_image img").fadeOut(Number(settings.fadeSpeed), function()
		{
			$("#placeholder").replaceWith($("#selected_image img")).appendTo("#selected_image");
			$("#preloaded_images img:eq(" + local.current + ")").css("display", "none").replaceWith($("#placeholder")).appendTo("#selected_image").fadeIn(Number(settings.fadeSpeed), function()
			{
				slideshowFramework.status = 1;
			});
			if(Number(settings.transitionImages))
			{
				slideshowFramework.timeout = setTimeout("slideshowFramework.advance()", Number(Drupal.settings.slideshowFramework.transitionSpeed));
			}
		});
		local.moveIndicator();
	}
};

slideshowFramework.moveIndicator = function()
{
	var local = slideshowFramework;
	var settings = Drupal.settings.slideshowFramework;
	var factor = 0;
	if((local.total - 7 ) > 0)
	{
		factor = (522 / (local.total - 1));
	}
	else
	{
		factor = 87;
	}
	var indicatorPos = local.current * factor;
	var tDuration = (Number(settings.fadeSpeed) * 2);
	$("#thumb_indicator").animate
	(
		{
			top : indicatorPos
		},
		tDuration,
		"swing"
	);
	if((local.total - 7) > 0)
	{
		factor = ((local.total - 7) / (local.total - 1)) * 87 * -1;
	}
	else
	{
		factor = 0;
	}
	var sliderPos = local.current * factor;
	$("#slider").animate
	(	
		{
			top : sliderPos
		},
		tDuration,
		"swing"
	);
};

slideshowFramework.thumbs = function()
{
	var local = slideshowFramework;
	$("#thumbs .thumb img").each(function() 
	{
		$(this).click(function()
		{
			if(slideshowFramework.status)
			{
				slideshowFramework.current = $("#thumbs .thumb img").index(this);
				local.exchangeImage();
			}
			return false;
		});
	});
	$("#thumbs a").each(function()
	{
		// remove dotted outline in FF and other browsers
		$(this).css("outline", "none");
		// remove dotted outline in IE
		$(this).focus(function()
		{
			$(this).blur();
		});
	});
};

slideshowFramework.advance = function()
{
	var local = slideshowFramework;
	if(local.status)
	{
		slideshowFramework.current = ((slideshowFramework.current + 1) < slideshowFramework.total) ? slideshowFramework.current + 1 : 0;
		local.exchangeImage();
	}
};

slideshowFramework.downloadLinks = function()
{
	$(".thumb").hover
	(
		function()
		{
			$(this).children(".image_download_link").fadeIn('fast');
		},
		function()
		{
			$(this).children(".image_download_link").fadeOut('fast');
		}
	);
};

slideshowFramework.fullscreen = function(bkgroundColor)
{
	var fullscreenOn = false;
	$("#slideshow_framework_image_descriptions").before("<p id=\"slideshow_framework_fullscreen_link\"><a href=\"#\">" + Drupal.t("Fullscreen") + "</a></p>");
	$("body").append("<div id=\"slideshow_dimmer\">&nbsp;</div>");
	$("#slideshow_dimmer").css("background-color", bkgroundColor);
	$("#slideshow_framework_fullscreen_link").click(function()
	{
		if(!fullscreenOn)
		{
			$("#slideshow_framework").css("z-index", 201);
			$("#slideshow_dimmer").fadeIn(400, function()
			{
				fullscreenOn = true;
			});
		}
		else
		{
			$("#slideshow_dimmer").fadeOut(400, function()
			{
				$("#slideshow_framework").css("z-index", "");
				fullscreenOn = false;
			});
		}
		return false;
	});
};

Drupal.behaviors.slideshowFramework = function()
{
	var settings = Drupal.settings.slideshowFramework;
	slideshowFramework.total = $("#preloaded_images img").length + 1;
	if(slideshowFramework.total > 1)
	{
		$("#selected_image img").before("<div id=\"slideshow_left_button\"><a href=\"#\"><</a></div><div id=\"slideshow_right_button\"><a href=\"#\">></a></div>");
		if(settings.allowFullscreen)
		{
			slideshowFramework.fullscreen(settings.fullscreenBackground);
		}
		$("#thumbs").prepend("<div id=\"thumb_indicator\"></div>");
		$("#thumbs .thumb").css("outline", "none");
		$("#thumbs .selected img").css("border", "none");
		$("#thumbs .selected a img").css("height", "77px");
		slideshowFramework.titlesExist = $(".slideshow_framework_image_title").length;
		slideshowFramework.descriptionsExist = $(".slideshow_framework_image_description").length;
		slideshowFramework.buttons();
		slideshowFramework.thumbs();
		slideshowFramework.downloadLinks();
		if(Number(settings.transitionImages))
		{
			slideshowFramework.timeout = setTimeout("slideshowFramework.advance()", Number(Drupal.settings.slideshowFramework.transitionSpeed));
		}
	}
}